<?php
/*
!!! -    !!!
*/

set_time_limit(300);

define('INIT_BB', true);
define('BB_ROOT', './');
require(BB_ROOT ."common.php");
require(INC_DIR ."bbcode.php");
require(INC_DIR ."functions_post.php");
require(INC_DIR ."functions_torrent.php");
require(INC_DIR ."class.snoopy.php");

$url = isset($_POST['url']) ? $_POST['url'] : '';
$url = str_replace('http://www.', 'http://', $url);
$hidden_form_fields = $message = $subject = '';

$forum_id = (int) request_var('forum_id', '');

if(!$url)
{
    // Start session management
	$user->session_start();

    if (IS_ADMIN)
	{
		$forum_select_mode = 'admin';
	}
	else
	{
		$not_auth_forums_csv = $user->get_not_auth_forums(AUTH_VIEW);
		$forum_select_mode = explode(',', $not_auth_forums_csv);
	}

    $template->assign_vars(array(
        'URL'          => true,
        'SELECT_FORUM' => get_forum_select($forum_select_mode, 'forum_id', 0),
    ));
}
else
{
    // Start session management
	$user->session_start(array('req_login' => true));

    if($_POST['tracker'] == 'rutracker')
    {
	    if (!preg_match("/http:\/\/rutracker.org\/forum\/viewtopic.php\?t=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://rutracker.org/forum/viewtopic.php?t=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "rutracker.org";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://rutracker.org/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://login.rutracker.org/forum/login.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'login_username' => "", //
			'login_password' => "", //
			'login' => $lang['LOGIN'],
		);
		$snoopy->submit($submit_url, $submit_vars);

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<input id="thx-btn" type="button"');
		$content = substr($content, 0, $pos);

	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function rutracker($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ('#<h1 class="maintitle"><a href=".*?">([\s\S]*?)</a></h1>#', $text, $source, PREG_SET_ORDER);
			    $text = @$source[0][1];
				$text = str_replace('<wbr>', '', $text);
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ('#<a href="http://dl.rutracker.org/forum/dl.php\?t=(.*?)" class#', $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    else
		    {
				$pos = strpos($text, '<div class="post_body"');
				$text = substr($text, $pos);
				$pos = strpos($text, '<div class="clear"></div>');
				$text = substr($text, 0, $pos);
				$text = preg_replace('/<div class="post_body" id=".*?">/', '', $text);

				$text = preg_replace('#<img class="smile" src=".*?" align="absmiddle" border="0" />#', '', $text);
				$text = preg_replace('#\n<h3 class="sp-title">.*?</h3>#', '', $text);
				$text = str_replace('<div class="q-wrap">', '', $text);
				$text = str_replace('<div class="sp-wrap">', '', $text);
				$text = str_replace('<div class="c-wrap">', '', $text);
				$text = preg_replace('#<a name=".*?"></a>#', '', $text);
				$text = preg_replace('#<a class="postLink-name" href=".*?">([\s\S]*?)</a>#', '$1', $text);
				$text = str_replace('<span class="post-hr">-</span>', "\n[hr]\n", $text);
                $text = preg_replace('#<pre class="post-pre">([\s\S]*?)</pre>#', '$1', $text);
				$text = preg_replace('#<div style="margin-.*?">([\s\S]*?)</div>#', '$1', $text);
				$text = preg_replace('/<var class="postImg" title="(.*?)">&#10;<\/var>/', '[img]$1[/img]', $text);
				$text = preg_replace('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', "[img=\\1]\\2[/img]\n", $text);
				$text = str_replace('<span class="post-br"><br /></span>', "\n\n", $text);

				$text = preg_replace('/<br.*?>/', '', $text);
				$text = preg_replace('/<ul type="(.*?)">/', '[list=$1]', $text);
				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<span class="post-b">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span class="post-u">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span class="post-i">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span class="post-s">([^<]*?)<(?=\/)\/span>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal;">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span class="post-align" style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);
					$text = preg_replace('/<a href="([^<]*?)" class="postLink">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<div class="sp-body" title="([^<]*?)">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $text);
					$text = preg_replace('/<div class="sp-body">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[spoiler]\n\\1\n[/spoiler]", $text);
					$text = preg_replace('/<div class="q">([^<]*?)<(?=\/)\/div>([^<]*?)<([^<]*?)\/div>/', "[quote]\n\\1\n[/quote]", $text);
					$text = preg_replace('/<div class="q" head="([^<]*?)">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[quote=\"\\1\"]\n\\2\n[/quote]", $text);
					$text = preg_replace('/<div class="c-head"><b>([^<]*?)<\/b><\/div>([^<]*?)<div class="c-body">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[code]\n\\3\n[/code]", $text);
					$text = preg_replace('/<div style="text-align:([^<]*?)">([^<]*?)<(?=\/)\/div>/', '<div>[align=$1]$2[/align]</div>', $text);
				}

			    //   
				$text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = rutracker($content))
	    {
		    $id = rutracker($content, 'torrent');;

	        $snoopy->submit("http://dl.rutracker.org/forum/dl.php?t=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    //if((array_key_exists('announce-list', $tor)) || $tor['announce'])
			    //{
				    $new_name = md5($torrent);
				    $file = fopen('files/'. $new_name .'.torrent', 'w');
					fputs($file, $torrent);
			        fclose($file);

				    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
					$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
					$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
					$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'.$new_name.'.torrent" />';
					$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
					$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
					$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
			        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
			        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
			        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
		        //}
		    }
	    }
	    $subject = rutracker($content, 'title');
    }
    elseif($_POST['tracker'] == 'pornolab')
    {
	    if (!preg_match("/http:\/\/pornolab.net\/forum\/viewtopic.php\?t=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://pornolab.net/forum/viewtopic.php?t=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "pornolab.net";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://pornolab.net/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://pornolab.net/forum/login.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'login_username' => "", //
			'login_password' => "", //
			'login' => $lang['LOGIN'],
		);
		$snoopy->submit($submit_url, $submit_vars);

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<form method="post" action="thx.php">');
		$content = substr($content, 0, $pos);

	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function pornolab($text, $mode=false)
		{

			if($mode == 'title')
			{
				preg_match_all ("#<h1 class=\"maintitle\"><a href=\".*?\">([\s\S]*?)</a></h1>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
				$text = str_replace('<wbr>', '', $text);
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<a href=\"dl.php\?t=([\s\S]*?)\" class#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    else
		    {
				$pos = strpos($text, '<div class="post_body"');
				$text = substr($text, $pos);
				$pos = strpos($text, '<div class="clear"></div>');
				$text = substr($text, 0, $pos);
				$text = preg_replace('/<div class="post_body" id=".*?">/', '', $text);

				$text = preg_replace('#<img class="smile" src=".*?" align="absmiddle" border="0" />#', '', $text);
				$text = preg_replace('#\n<h3 class="sp-title">.*?</h3>#', '', $text);
				$text = str_replace('<div class="q-wrap">', '', $text);
				$text = str_replace('<div class="sp-wrap">', '', $text);
				$text = str_replace('<div class="c-wrap">', '', $text);
				$text = preg_replace('#<a name=".*?"></a>#', '', $text);
				$text = preg_replace('#<a class="postLink-name" href=".*?">([\s\S]*?)</a>#', '$1', $text);
				$text = str_replace('<span class="post-hr">-</span>', "\n[hr]\n", $text);
                $text = preg_replace('#<pre class="post-pre">([\s\S]*?)</pre>#', '$1', $text);
				$text = preg_replace('#<div style="margin-.*?">([\s\S]*?)</div>#', '$1', $text);
				$text = preg_replace('/<var class="postImg" title="(.*?)">&#10;<\/var>/', '[img]$1[/img]', $text);
				$text = preg_replace('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', "[img=\\1]\\2[/img]\n", $text);
				$text = str_replace('<span class="post-br"><br /></span>', "\n\n", $text);

				$text = preg_replace('/<br.*?>/', '', $text);
				$text = preg_replace('/<ul type="(.*?)">/', '[list=$1]', $text);
				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<span class="post-b">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span class="post-u">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span class="post-i">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span class="post-s">([^<]*?)<(?=\/)\/span>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal;">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span class="post-align" style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);
					$text = preg_replace('/<a href="([^<]*?)" class="postLink">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<div class="sp-body" title="([^<]*?)">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $text);
					$text = preg_replace('/<div class="sp-body">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[spoiler]\n\\1\n[/spoiler]", $text);
					$text = preg_replace('/<div class="q">([^<]*?)<(?=\/)\/div>([^<]*?)<([^<]*?)\/div>/', "[quote]\n\\1\n[/quote]", $text);
					$text = preg_replace('/<div class="q" head="([^<]*?)">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[quote=\"\\1\"]\n\\2\n[/quote]", $text);
					$text = preg_replace('/<div class="c-head"><b>([^<]*?)<\/b><\/div>([^<]*?)<div class="c-body">([^<]*?)<(?=\/)\/div>([\s\S]*?)<([^<]*?)\/div>/', "[code]\n\\3\n[/code]", $text);
					$text = preg_replace('/<div style="text-align:([^<]*?)">([^<]*?)<(?=\/)\/div>/', '<div>[align=$1]$2[/align]</div>', $text);
				}

			    //   
				$text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = pornolab($content))
	    {
		    $id = pornolab($content, 'torrent');;

	        $snoopy->submit("http://pornolab.net/forum/dl.php?t=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'.$new_name.'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
	        }
	    }
	    $subject = pornolab($content, 'title');
    }
    elseif($_POST['tracker'] == 'tapochek')
    {
        if (!preg_match("/http:\/\/tapochek.net\/viewtopic.php\?t=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://tapochek.net/viewtopic.php?t=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "tapochek.net";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://tapochek.net/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$snoopy->cookies['bb_data'] = urldecode(''); // 

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<p><img src="images/icon_dn.gif"');
		$content = substr($content, 0, $pos);

	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function tapochek($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<h1 class=\"maintitle\"><a href=\".*?\">([\s\S]*?)</a></h1>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
				$text = str_replace('<wbr>', '', $text);
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<th colspan=\"3\" class=\"genmed\">(.*?).torrent</th>[\s\S]*?<a href=\"download.php\?id=(.*?)\" #", $text, $source, PREG_SET_ORDER);
			    $text = $source[0];
		    }
		    else
		    {
				$pos = strpos($text, '<div class="post_body"');
				$text = substr($text, $pos);
				$pos = strpos($text, '<div class="spacer_8"></div>');
				$text = substr($text, 0, $pos);
                $text = str_replace('<div class="post_body">', '', $text);
                $text = str_replace('<wbr>', '', $text);

				//preg_match_all ("#<div class=\"post_body\" id=\".*?\">([\s\S]*?)<div class=\"clear\"></div>#", $text, $source, PREG_SET_ORDER);
			    //$text = $source[0][1];

				$text = preg_replace('/<img class="smile" src=".*?" align="absmiddle" border="0" \/>/', '', $text);
                $text = str_replace('<div class="q-wrap">', '', $text);
				$text = str_replace('<div class="sp-wrap">', '', $text);
				$text = str_replace('<div class="c-wrap">', '', $text);
                $text = str_replace('<div class="clear"></div>', '', $text);

                $text = preg_replace('/<div style="display: none;">.*?<\/div>/', '', $text);

				$text = str_replace('<hr />', "\n[hr]\n", $text);
                $text = preg_replace('/<var class="postImg" title="(.*?)">&#10;<\/var>/', '[img]$1[/img]', $text);
				$text = preg_replace('/<var class="postImg postImgAligned img-(.*?)" title="([\s\S]*?)">&#10;<\/var>/', "[img=\\1]\\2[/img]\n", $text);

				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);
				$text = str_replace('<ol type="1">', '[list=1]', $text);
				$text = str_replace('<ol type="a">', '[list=a]', $text);
				$text = str_replace('</ol>', '[/list]', $text);
				$text = str_replace('', "\n", $text);
				$text = str_replace('<div></div>', "\n", $text);
                $text = preg_replace('/<a href="([^<]*?)" rel=".*?"><img src=".*?" \/>&nbsp;<\/a>/', '[thumbnails]$1[/thumbnails]', $text);

                $text = str_replace('<br clear="all" />', "\n[br]\n", $text);
                $text = str_replace('<br />', "\n", $text);

                $text = str_replace('<div', '<span', $text);
                $text = str_replace('</div>', '</span>', $text);
                $text = str_replace('<a', '<span', $text);
                $text = str_replace('</a>', '</span>', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<span style="font-weight: bold;">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span style="text-decoration: underline;">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span style="font-style: italic;">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal;">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);

					$text = preg_replace('/<span href="([^<]*?)" class="postLink">([^<]*?)<(?=\/)\/span>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<span class="sp-body" title="([^<]*?)">([^<]*?)<(?=\/)\/span>([\s\S]*?)<([^<]*?)\/span>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $text);
					$text = preg_replace('/<span class="sp-body">([^<]*?)<(?=\/)\/span>([\s\S]*?)<([^<]*?)\/span>/', "[spoiler]\n\\1\n[/spoiler]", $text);
					$text = preg_replace('/<span class="q">([^<]*?)<(?=\/)\/span>([^<]*?)<([^<]*?)\/span>/', "[quote]\n\\1\n[/quote]", $text);
					$text = preg_replace('/<span class="q" head="([^<]*?)">([^<]*?)<(?=\/)\/span>([\s\S]*?)<([^<]*?)\/span>/', "[quote=\"\\1\"]\n\\2\n[/quote]", $text);
					$text = preg_replace('/<span class="c-head"><b>([^<]*?)<\/b><\/span>([^<]*?)<span class="c-body">([^<]*?)<(?=\/)\/span>([\s\S]*?)<([^<]*?)\/span>/', "[code]\n\\3\n[/code]", $text);
				}

			    //   
				$text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = tapochek($content))
	    {
		    $tor = tapochek($content, 'torrent');;
            $id = $tor[2];
            $name = $tor[1];

	        $snoopy->submit("http://tapochek.net/download.php?id=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. $name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
            }
        }
	    $subject = tapochek($content, 'title');
    }
    elseif($_POST['tracker'] == 'rustorka')
    {
        if (!preg_match("/http:\/\/rustorka.com\/forum\/viewtopic.php\?t=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://rustorka.com/forum/viewtopic.php?t=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "rustorka.com";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://rustorka.com/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://rustorka.com/forum/login.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'login_username' => "", //
			'login_password' => "", //
			'login' => $lang['LOGIN'],
		);
		$snoopy->submit($submit_url, $submit_vars);

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<table width="100%" border="0" align="center">');
		$content = substr($content, 0, $pos);

	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function rustorka($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<h1 class=\"maintitle\"><a href=\".*?\">([\s\S]*?)</a></h1>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
				$text = str_replace('<wbr>', '', $text);
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<th colspan=\"3\" class=\"genmed\">(.*?).torrent</th>[\s\S]*?<a href=\"download.php\?id=(.*?)\" #", $text, $source, PREG_SET_ORDER);
			    $text = $source[0];
		    }
		    else
		    {
				$pos = strpos($text, '<div class="post_body"');
				$text = substr($text, $pos);
				$pos = strpos($text, '<div class="spacer_8"></div>');
				$text = substr($text, 0, $pos);
                $text = preg_replace('/<div class="post_body">/', '', $text);
                $text = str_replace('<wbr>', '', $text);
                $text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				//preg_match_all ("#<div class=\"post_body\" id=\".*?\">([\s\S]*?)<div class=\"clear\"></div>#", $text, $source, PREG_SET_ORDER);
			    //$text = $source[0][1];

				$text = preg_replace('/<img class="smile" src=".*?" align="absmiddle" border="0" \/>/', '', $text);
                $text = str_replace('<div class="clear"></div>', '', $text);
                $text = preg_replace('/<!--\/.*?-->/', '', $text);
				$text = str_replace('<hr />', "\n[hr]\n", $text);
                $text = preg_replace('/<div class="postImg-wrap" style=".*?" align="center"><img src="(.*?)" id="postImgAligned" class="postImg" alt="pic" \/><\/div>/', "[align=center][img]\\1[/img][/align]\n", $text);
				$text = preg_replace('/<div class="postImg-wrap" style=".*?" align="(.*?)"><img src="(.*?)" id="postImgAligned" class="postImg" alt="pic" \/><\/div>/', "[img=\\1]\\2[/img]\n", $text);
				
				$text = preg_replace('/<img src="(.*?)" id="postImg" class="postImg" align="absmiddle" hspace="0" vspace="4" alt="pic" \/>/', '[img]$1[/img]', $text);

				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);
				$text = str_replace('<br /><br />', "\n", $text);
				$text = str_replace('<br clear="all" />', "\n[br]\n", $text);
				$text = str_replace('<div></div>', "\n", $text);
				$text = str_replace('<div', '<span', $text);
                $text = str_replace('</div>', '</span>', $text);
                $text = str_replace('<a', '<span', $text);
                $text = str_replace('</a>', '</span>', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<span style="font-weight: bold;">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span style="text-decoration: underline;">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span style="font-style: italic;">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal;">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);

					$text = preg_replace('/<span href="([^<]*?)" class="postLink">([^<]*?)<(?=\/)\/span>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<p class="q_head"><b>.*?<\/b><\/p>[\s\S]*?<div class="q">([^<]*?)<(?=\/)\/div><!--\/q-->/', "[quote]\n\\1\n[/quote]", $text);
					$text = preg_replace('/<p class="q_head"><b>(.*?)<\/b>.*?<\/p>[\s\S]*?<div class="q">([^<]*?)<(?=\/)\/div><!--\/q-->/', "[quote=\"\\1\"]\n\\2\n[/quote]", $text);
					$text = preg_replace('/<span class="code">([^<]*?)<(?=\/)\/span>/', "[code]\n\\1\n[/code]", $text);
					$text = preg_replace('/<span class="spoiler-wrap.*? clickable">([^<]*?)<\/span>[^<]*?<span class="spoiler-body">([^<]*?)<(?=\/)\/span>[^<]*?<(?=\/)\/span>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $text);
			    }

			    //   
				$text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = rustorka($content))
	    {
		    $tor = rustorka($content, 'torrent');
            $id = $tor[2];
            $name = $tor[1];

	        $snoopy->submit("http://rustorka.com/forum/download.php?id=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. $name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
            }
	    }
	    $subject = rustorka($content, 'title');
    }
    elseif($_POST['tracker'] == 'rutor')
    {
    	if (!preg_match("/http:\/\/rutor.org\/torrent\//", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://rutor.org/torrent/xxxx');</script>");
	    }

        $snoopy = new Snoopy;
		$snoopy->host = "rutor.org";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://rutor.org/";
		$snoopy->rawheaders["Pragma"] = "no-cache";
	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = $snoopy->results;
	    //$content = iconv('windows-1251', 'UTF-8', $content);
	    $pos = strpos($content, '<td class="header"');
		$content = substr($content, 0, $pos);
  	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function rutor($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<h1>([\s\S]*?)</h1>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<a href=\"http://d.rutor.org/download/([\s\S]*?)\"><img src=\"http://s.rutor.org/t/down.png\"> .*? ([\s\S]*?).torrent</a>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0];
		    }
		    else
		    {
				preg_match_all ("#<tr><td style=\"vertical-align:top;\"></td><td>([\s\S]*?)</td></tr>#si", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];

				$text = preg_replace('/<br.*?>/', "", $text);
                $text = preg_replace('/<a href="\/tag\/.*?" target="_blank">([\s\S]*?)<\/a>/', '$1', $text);
                $text = preg_replace('/<div class="hidewrap"><div class="hidehead" onclick="hideshow.*?">([\s\S]*?)<\/div><div class="hidebody"><\/div><textarea class="hidearea">([\s\S]*?)<\/textarea><\/div>/', "[spoiler=\"\\1\"]\\2[/spoiler]", $text);
                $text = preg_replace('/<a href="([\s\S]*?)" target="_blank">([\s\S]*?)<\/a>/', '[url=$1]$2[/url]', $text);
                $text = preg_replace('/<img src="(.*?)" style="float:(.*?);" \/>/', '[img=$2]$1[/img]', $text);
                $text = preg_replace('/<img src="([\s\S]*?)" \/>/', '[img]$1[/img]', $text);

                $text = str_replace('<center>', '[align=center]', $text);
				$text = str_replace('</center>', '[/align]', $text);
                $text = str_replace('<hr />', '[hr]', $text);

				$text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<b>([^<]*?)<(?=\/)\/b>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<u>([^<]*?)<(?=\/)\/u>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<i>([^<]*?)<(?=\/)\/i>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<s>([^<]*?)<(?=\/)\/s>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<font size="([^<]*?)">([^<]*?)<(?=\/)\/font>/', "[size=2\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="color:([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);
				    $text = preg_replace('/<span style="font-family:([^<]*?);">([^<]*?)<(?=\/)\/span>/', '[font=$1]$2[/font]', $text);
				}
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = rutor($content))
	    {
		    $tor = rutor($content, 'torrent');
            $name = $tor[2];
            $id = $tor[1];

		    $torrent = file_get_contents("http://rutor.org/download/". $id);
		    $new_name = md5($torrent);
		    $file = fopen('files/'. $new_name .'.torrent', 'w');
			fputs($file, $torrent);
	        fclose($file);

		    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
			$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
			$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
			$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. $name .'.torrent" />';
			$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
			$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
			$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
	        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
	        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
	        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';

	    }
	    $subject = rutor($content, 'title');

    }
    elseif($_POST['tracker'] == 'anidub')
    {
        if (!preg_match("/http:\/\/tr.anidub.com\/details.php\?id=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://tr.anidub.com/details.php?id=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "tr.anidub.com";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://tr.anidub.com/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://tr.anidub.com/takelogin.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'username' => "",
			'password' => "",
		);
		$snoopy->submit($submit_url, $submit_vars);

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $content = preg_replace('/([\r\n])[\s]+/is', "\\1", $content);
	    $pos = strpos($content, '<table width="100%" border="1" cellspacing="0" cellpadding="5">');
	    $content = substr($content, $pos);
	    $pos = strpos($content, '<form action="thanks.php" method="post" id="thanksForm">');
		$content = substr($content, 0, $pos);

	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

        function anidub($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<b>([\s\S]*?)</b>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<a href=\"download.php\?id=(.*?)&amp;name=(.*?).torrent\">#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0];
		    }
		    else
		    {
				preg_match_all ("#<br></a><br>([\s\S]*?)<br></td></tr><tr>#", $text, $source, PREG_SET_ORDER);
				preg_match_all ('/<img src="(.*?)" title=".*?" width="250" alt=".*?"><br>/', $text, $pic, PREG_SET_ORDER);
			    $poster = ($pic[0][1]) ? "[img=right]". $pic[0][1] ."[/img]\n\n" : "";
			    $text = $poster . $source[0][1];

                $text = str_replace('<a class=\'spoiler_title_c sp-pic_plus_no_c\' width=\'100%\'>', '<a class=spoiler_title>', $text);
                $text = str_replace('<a class=spoiler_title><b>', '<a class=spoiler_title>', $text);
                $text = str_replace('<a class=spoiler_title><b>', '<a class=spoiler_title>', $text);
                $text = preg_replace('/<a class=spoiler_title><.*?>(.*?)<.*?><\/b>/', "<a class=spoiler_title>\\1", $text);

                $text = str_replace('<br />', '', $text);
                $text = preg_replace('/<img class="linked-image" src="(.*?)".*?\/>/', "[img]\\1[/img]", $text);
                $text = preg_replace('/<img border="0" src=".*?">/', '', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<b>([^<]*?)<(?=\/)\/b>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<u>([^<]*?)<(?=\/)\/u>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<i>([^<]*?)<(?=\/)\/i>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<s>([^<]*?)<(?=\/)\/s>/', '[s]$1[/s]', $text);

					$text = preg_replace('/<font style="font-size: ([^<]*?)pt">([^<]*?)<(?=\/)\/font>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span class="post-align" style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\\2[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);

					$text = preg_replace('/<a href="([^<]*?)" title=".*?">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
                    $text = preg_replace('/<a class=spoiler_title>(.*?)<\/a><div class=\'spoiler\'>([\s\S]*?)<(?=\/)\/div>/', "[spoiler=\"\\1\"]\\2[/spoiler]", $text);
                }
                $text = str_replace('</b>', '', $text);
                $text = str_replace('<br>', '', $text);
                $text = str_replace('</td></tr><tr>', '', $text);
                $text = preg_replace('/<td valign=middle align=right>(.*?)<\/td><td>/', "\n\n\\1: ", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

	    if ($message = anidub($content))
	    {
		    $tor = anidub($content, 'torrent');
            $name = $tor[2];
            $id = $tor[1];

	        $snoopy->submit("http://tr.anidub.com/download.php?id=". $id ."&name=". $name .".torrent");
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. urldecode($name) .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
	        }
	    }
	    $subject = anidub($content, 'title');
    }
    elseif($_POST['tracker'] == 'lostfilm')
    {
    	if (!preg_match("/http:\/\/lostfilm.tv\/details.php\?id=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://lostfilm.tv/details.php?id=xxxx');</script>");
	    }
	    $snoopy = new Snoopy;
		$snoopy->host = "lostfilm.tv";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://lostfilm.tv/";
		$snoopy->rawheaders["Pragma"] = "no-cache";
        $snoopy->cookies = array (
	        'uid'              => '',
            'pass'             => '',
            'phpbb2mysql_data' => urldecode(''),
            'phpbb2mysql_sid'  => '',
            'b_u_stat'		   => urldecode(''),
            '__utma'		   => '',
            '__utmb'		   => '',
            '__utmz'		   => '',
        );
	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);

	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<a href="javascript:{}" onClick="ShowHappyUsers');
		$content = substr($content, 0, $pos);
  	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function lostfilm($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<title>.*?\. ([\s\S]*?)</title>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ('#<a href="/download.php\?id=(.*?)&(.*?).torrent" onMouseOver=".*?" class="a_download" ></a>#', $text, $sources, PREG_SET_ORDER);
			    $text = $sources[0];
		    }
		    else
		    {
				$text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);
				preg_match_all ("#class=\"a_download\" onClick=\".*?\"></a>\n</div>\n<div>([\s\S]*?)\n<br />\n<br />\n<b>#si", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];

				$text = preg_replace('/<br.*?>/', "", $text);
                $text = preg_replace('/<img src="([\s\S]*?)" alt="" \/>/', '[img]$1[/img]', $text);

                $text = str_replace('<strong>', '[b]', $text);
                $text = str_replace('</strong>', '[/b]', $text);

                $text = str_replace(' target="_blank"', '', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<b.*?>([^<]*?)<(?=\/)\/b>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<i>([^<]*?)<(?=\/)\/i>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<u>([^<]*?)<(?=\/)\/u>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<s>([^<]*?)<(?=\/)\/s>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<font color="([^<]*?)">([^<]*?)<(?=\/)\/font>/', '[color=$1]$2[/color]', $text);
				    $text = preg_replace('/<a href="([^<]*?)">([^<]*?)<(?=\/)\/a>/', '[url=http://www.lostfilm.tv$1]$2[/url]', $text);
                }
                $text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

		if ($message = lostfilm($content))
	    {
		    $tor = lostfilm($content, 'torrent');
		    $id = $tor[1];
		    $name = $tor[2];

		    $snoopy->submit("http://lostfilm.tv/download.php?id=". $id ."&". $name .".torrent");
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. $name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
	        }
	    }
	    $subject = lostfilm($content, 'title');
    }
    elseif($_POST['tracker'] == 'uniongang')
    {
    	if (!preg_match("/http:\/\/uniongang.tv\/details.php\?id=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://uniongang.tv/details.php?id=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "uniongang.tv";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://uniongang.tv/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

    	$snoopy->cookies = array (
			'MG_2723'   => '',
			'new_pass2' => '',
			'new_uid'   => '',
			'PHPSESSID' => '',
		);
		$snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $content = preg_replace('/([\r\n])[\s]+/is', "\\1", $content);
	    $pos = strpos($content, '<table width="100%" border="1" cellspacing="0" cellpadding="5">');
	    $content = substr($content, $pos);
	    $pos = strpos($content, '<form method="post" action="takerate.php">');
		$content = substr($content, 0, $pos);

		function uniongang($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<a class=\"index\" href=\"download.php\?id=.*?\"><b>(.*?)</b></a>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#<a class=\"index\" href=\"download.php\?id=(.*?)\">#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
		    }
		    else
		    {
				preg_match_all ("#\" /><br />([\s\S]*?)</td></tr>#", $text, $source, PREG_SET_ORDER);
				preg_match_all ('/<img class="linked-image" src="(.*?)" border="0"/', $text, $pic, PREG_SET_ORDER);
			    $poster = ($pic[0][1]) ? "[img=right]". $pic[0][1] ."[/img]" : "";
			    $text = $poster . $source[0][1];

                $text = str_replace('<textarea>', '', $text);
                $text = str_replace('</textarea>', '', $text);

                $text = str_replace('<br />', '', $text);
                $text = preg_replace('/<img class="linked-image" src="(.*?)".*?\/>/', "[img]\\1[/img]", $text);
                $text = preg_replace('/<img border="0" src=".*?">/', '', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<b>([^<]*?)<(?=\/)\/b>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<u>([^<]*?)<(?=\/)\/u>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<i>([^<]*?)<(?=\/)\/i>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<s>([^<]*?)<(?=\/)\/s>/', '[s]$1[/s]', $text);

					$text = preg_replace('/<font style="font-size: ([^<]*?)pt">([^<]*?)<(?=\/)\/font>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span class="post-align" style="text-align: ([^<]*?);">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\\2[/align]", $text);
					$text = preg_replace('/<span style="color: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);

					$text = preg_replace('/<a href="([^<]*?)" title=".*?">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
                    $text = preg_replace('/<a href="\/([^<]*?)">([^<]*?)<(?=\/)\/a>/', '[url=http://www.uniongang.tv/$1]$2[/url]', $text);
                    $text = preg_replace('/<div class="spoiler-wrap"><div class="spoiler-head folded clickable">([^<]*?)<\/div><div class="spoiler-body">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', "[spoiler=\"\\1\"]\n\\2\n[/spoiler]", $text);
				}

                $text = str_replace('</td></tr><tr>', '', $text);
                $text = preg_replace('/<td valign=middle align=right>(.*?)<\/td><td>/', "\n\n\\1: ", $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

		if ($message = uniongang($content))
	    {
		    $id = uniongang($content, 'torrent');

	        $snoopy->submit("http://uniongang.tv/download.php?id=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'.$new_name.'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
	        }
	    }
	    $subject = uniongang($content, 'title');
    }
    elseif($_POST['tracker'] == 'nnmclub')
    {
    	if (!preg_match("/http:\/\/nnm-club.ru\/forum\/viewtopic.php\?t=/", $url))
	    {
	    	meta_refresh('', '2');
	    	bb_die("false link<script>alert('false link http://nnm-club.ru/forum/viewtopic.php?t=xxxx');</script>");
	    }

	    $snoopy = new Snoopy;
		$snoopy->host = "nnm-club.ru";
		$snoopy->agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
		$snoopy->referer = "http://nnm-club.ru/";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://nnm-club.ru/forum/login.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'username' => "",
			'password' => "",
			'invite'   => "",
			'login'    => $lang['LOGIN'],
		);
		$snoopy->submit($submit_url, $submit_vars);

	    $snoopy->_httpmethod = "GET";
	    $snoopy->fetch($url);
	    $content = iconv('windows-1251', 'UTF-8', $snoopy->results);
	    $pos = strpos($content, '<td class="genmed" valign="middle" align="center" colspan="3" style="padding: 3px">');
		$content = substr($content, 0, $pos);
	    if (!$content)
	    {
	    	meta_refresh('', '2');
	    	bb_die('false content');
	    }

	    function nnmclub($text, $mode=false)
		{
			if($mode == 'title')
			{
				preg_match_all ("#<a class=\"maintitle\" href=\"viewtopic.php\?t=.*?\">(.*?)</a>#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0][1];
			}
		    elseif($mode == 'torrent')
		    {
		    	preg_match_all ("#style=\"padding: 3px\"><b>(.*?).torrent</b></td>[\s\S]*?<a href=\"download.php\?id=(.*?)\" class=\"genmed\">#", $text, $source, PREG_SET_ORDER);
			    $text = $source[0];
		    }
		    else
		    {
				$pos = strpos($text, '<span class="postbody">');
				$text = substr($text, $pos);
				$pos = strpos($text, '<!-- //bt -->');
				$text = substr($text, 0, $pos);
                $text = str_replace('<span class="postbody">', '', $text);
                $text = str_replace('<!--/spoiler-body-->', '', $text);
                $text = str_replace('<!--/spoiler-wrap-->', '', $text);

				//preg_match_all ("#<div class=\"post_body\" id=\".*?\">([\s\S]*?)<div class=\"clear\"></div>#", $text, $source, PREG_SET_ORDER);
			    //$text = $source[0][1];
                $text = preg_replace('/([\r\n])[\s]+/is', "\\1", $text);

				$text = preg_replace('/<img src=".*?" alt=".*?" border="0"\/>/', '', $text);
				$text = str_replace('<hr />', "[hr]", $text);
                $text = preg_replace('/<var class="postImg" title="(.*?)">&#10;<\/var>/', '[img]$1[/img]', $text);
				$text = preg_replace('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', "[img=\\1]\\2[/img]\n", $text);
				$text = str_replace('<span class="post-br"><br /></span>', "\n[br]\n", $text);

				$text = str_replace('<br />', "\n", $text);
				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);
				$text = str_replace('<div class="spoiler-wrap">', '', $text);
				$text = str_replace('<center>', "[align=center]", $text);
                $text = str_replace('</center>', "[/align]", $text);

                //<table width="90%" cellspacing="1" cellpadding="3" border="0" align="center"><tr>          <td><span class="genmed"><b>:</b></span></td>        </tr>        <tr>          <td class="quote">132</td>        </tr></table>

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

				for ($i=0; $i<=20; $i++)
				{
					$text = preg_replace('/<span style="font-weight: bold">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span style="text-decoration: underline">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span style="font-style: italic">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span style="text-decoration: line-through">([^<]*?)<(?=\/)\/span>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span style="text-align: ([^<]*?); display: block;">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
                    $text = preg_replace('/<span style="color: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);
					$text = preg_replace('/<a href="(.*?)".*?class="postLink">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<div class="spoiler-body">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', '[spoiler]$1[/spoiler]', $text);
				    //$text = preg_replace('/<div class="spoiler-body" title="([^<]*?)">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', '[spoiler="$1"]$2[/spoiler]', $text);
				}
				$text = str_replace('</span>', '', $text);
				$text = strip_tags(html_entity_decode($text));
			}
			return $text;
		}

		if ($message = nnmclub($content))
	    {
		    $tor = nnmclub($content, 'torrent');
		    $id = $tor[2];
		    $name = $tor[1];

		    $snoopy->submit("http://nnm-club.ru/forum/download.php?id=". $id);
		    $torrent = $snoopy->results;
		    $tor = bdecode($torrent);
		    if(count($tor))
		    {
			    $new_name = md5($torrent);
			    $file = fopen('files/'. $new_name .'.torrent', 'w');
				fputs($file, $torrent);
		        fclose($file);

			    $hidden_form_fields .= '<input type="hidden" name="add_attachment_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="posted_attachments_body" value="0" />';
				$hidden_form_fields .= '<input type="hidden" name="attachment_list[]" value="files/'. $new_name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filename_list[]" value="'. $name .'.torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="extension_list[]" value="torrent" />';
				$hidden_form_fields .= '<input type="hidden" name="mimetype_list[]" value="application/x-bittorrent" />';
				$hidden_form_fields .= '<input type="hidden" name="filesize_list[]" value="'. filesize('files/'. $new_name .'.torrent') .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="filetime_list[]" value="'. TIMENOW .'" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_id_list[]" value="" />';
		        $hidden_form_fields .= '<input type="hidden" name="attach_thumbnailsnail_list[]" value="0" />';
	        }
	    }
	    $subject = nnmclub($content, 'title');
    }
    $hidden_form_fields .= '<input type="hidden" name="mode" value="newtopic" />';
	$hidden_form_fields .= '<input type="hidden" name="'. POST_FORUM_URL .'" value="'.$forum_id.'" />';

    generate_smilies('inline');

	$template->assign_vars(array(
	    'SUBJECT'            => $subject,
	    'MESSAGE'            => $message,
        'S_POST_ACTION'      => "posting.php",

	    'L_SUBJECT'          => $lang['SUBJECT'],
		'L_MESSAGE_BODY'     => $lang['MESSAGE_BODY'],
		'L_SPELLCHECK'       => $lang['SPELLCHECK'],
		'L_CONFIRM_DELETE'   => $lang['CONFIRM_DELETE'],
		'L_DISABLE_SMILIES'  => $lang['DISABLE_SMILIES_POST'],
		'L_NOTIFY_ON_REPLY'  => $lang['NOTIFY'],
		'L_DELETE_POST'      => $lang['DELETE_POST'],
		'L_UPDATE_POST_TIME' => $lang['UPDATE_POST_TIME'],

		'L_EMPTY_MESSAGE'    => $lang['EMPTY_MESSAGE'],

		'L_FONT_COLOR'       => $lang['FONT_COLOR'],
		'L_COLOR_DEFAULT'    => $lang['COLOR_DEFAULT'],
		'L_COLOR_DARK_RED'   => $lang['COLOR_DARK_RED'],
		'L_COLOR_RED'        => $lang['COLOR_RED'],
		'L_COLOR_ORANGE'     => $lang['COLOR_ORANGE'],
		'L_COLOR_BROWN'      => $lang['COLOR_BROWN'],
		'L_COLOR_YELLOW'     => $lang['COLOR_YELLOW'],
		'L_COLOR_GREEN'      => $lang['COLOR_GREEN'],
		'L_COLOR_OLIVE'      => $lang['COLOR_OLIVE'],
		'L_COLOR_CYAN'       => $lang['COLOR_CYAN'],
		'L_COLOR_BLUE'       => $lang['COLOR_BLUE'],
		'L_COLOR_DARK_BLUE'  => $lang['COLOR_DARK_BLUE'],
		'L_COLOR_INDIGO'     => $lang['COLOR_INDIGO'],
		'L_COLOR_VIOLET'     => $lang['COLOR_VIOLET'],
		'L_COLOR_WHITE'      => $lang['COLOR_WHITE'],
		'L_COLOR_BLACK'      => $lang['COLOR_BLACK'],

		'L_FONT_SIZE'        => $lang['FONT_SIZE'],
		'L_FONT_TINY'        => $lang['FONT_TINY'],
		'L_FONT_SMALL'       => $lang['FONT_SMALL'],
		'L_FONT_NORMAL'      => $lang['FONT_NORMAL'],
		'L_FONT_LARGE'       => $lang['FONT_LARGE'],
		'L_FONT_HUGE'        => $lang['FONT_HUGE'],

		'L_STYLES_TIP'       => $lang['STYLES_TIP'],

	    'L_FONT_SEL'         => $lang['QR_FONT_SEL'],
		'L_FONT_COLOR_SEL'   => $lang['QR_COLOR_SEL'],
		'L_FONT_SIZE_SEL'    => $lang['QR_SIZE_SEL'],
		'L_STEEL_BLUE'       => $lang['COLOR_STEEL_BLUE'],
		'L_COLOR_GRAY'       => $lang['COLOR_GRAY'],
		'L_COLOR_DARK_GREEN' => $lang['COLOR_DARK_GREEN'],

		'POSTING_SUBJECT'    => true,
		'S_HIDDEN_FORM_FIELDS' => $hidden_form_fields,
	));
}

$template->assign_vars(array(
    'PAGE_TITLE'=> 'Grabber Trackers (rutracker.org  rutor.org anidub.com  pornolab.net lostfilm.tv uniongang.tv nnm-club.ru tapochek.net rustorka.com)',
));

print_page('posting.tpl');
?>